<?php
/**
*
* Show the products in a category
*
* @package	VirtueMart
* @subpackage
* @author RolandD
* @author Max Milbers
* @todo add pagination
* @link http://www.virtuemart.net
* @copyright Copyright (c) 2004 - 2010 VirtueMart Team. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* @version $Id: default.php 5378 2012-02-04 12:58:01Z Milbo $
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');
JHTML::_( 'behavior.modal' );
/* javascript for list Slide
  Only here for the order list
  can be changed by the template maker
*/
$js = "
jQuery(document).ready(function () {
	jQuery('.orderlistcontainer').hover(
		function() { jQuery(this).find('.orderlist').stop().show()},
		function() { jQuery(this).find('.orderlist').stop().hide()}
	)
});
";

$document = JFactory::getDocument();
$document->addScriptDeclaration($js);

/*$edit_link = '';
if(!class_exists('Permissions')) require(JPATH_VM_ADMINISTRATOR.DS.'helpers'.DS.'permissions.php');
if (Permissions::getInstance()->check("admin,storeadmin")) {
	$edit_link = '<a href="'.JURI::root().'index.php?option=com_virtuemart&tmpl=component&view=category&task=edit&virtuemart_category_id='.$this->category->virtuemart_category_id.'">
		'.JHTML::_('image', 'images/M_images/edit.png', JText::_('COM_VIRTUEMART_PRODUCT_FORM_EDIT_PRODUCT'), array('width' => 16, 'height' => 16, 'border' => 0)).'</a>';
}

echo $edit_link; */ ?>
<?php if($this->category->category_name) { ?>
<h1 class="ot-pagetitle componentheading"><span><?php echo $this->category->category_name; ?></span></h1>
<?php } ?>
<div class="category_description">
	<?php echo $this->category->category_description ; ?>
</div>
<?php
/* Show child categories */

if ( VmConfig::get('showCategory',1) ) {
	if ($this->category->haschildren) {

		// Category and Columns Counter
		$iCol = 1;
		$iCategory = 1;

		// Calculating Categories Per Row
		$categories_per_row = VmConfig::get ( 'categories_per_row', 3 );
		$category_cellwidth = ' width'.floor ( 100 / $categories_per_row );

		// Separator
		$verticalseparator = " vertical-separator";
		?>

		<div class="category-view">

		<?php // Start the Output
		if(!empty($this->category->children)){
		foreach ( $this->category->children as $category ) {

			// Show the horizontal seperator
			if ($iCol == 1 && $iCategory > $categories_per_row) { ?>
			<div class="horizontal-separator"></div>
			<?php }

			// this is an indicator wether a row needs to be opened or not
			if ($iCol == 1) { ?>
			<div class="row">
			<?php }

			// Show the vertical seperator
			if ($iCategory == $categories_per_row or $iCategory % $categories_per_row == 0) {
				$show_vertical_separator = ' ';
			} else {
				$show_vertical_separator = $verticalseparator;
			}

			// Category Link
			$caturl = JRoute::_ ( 'index.php?option=com_virtuemart&view=category&virtuemart_category_id=' . $category->virtuemart_category_id );

				// Show Category ?>
				<div class="category floatleft<?php echo $category_cellwidth . $show_vertical_separator ?>">
					<div class="spacer">
						<h2>
							<a href="<?php echo $caturl ?>" title="<?php echo $category->category_name ?>" class="ot-cat-sub"><span>
							<?php if ($category->images[0]->file_url_thumb) { ?>
								<div class="proimg-wrap">
									<?php /** @todo make image popup */
										echo $category->images[0]->displayMediaThumb("",false);
									?>
								</div>
							<?php } ?>
							<br />
							<?php echo '<div class="">'.$category->category_name ?>
							</span></a>
						</h2>
					</div>
				</div>
			<?php
			$iCategory ++;

		// Do we need to close the current row now?
		if ($iCol == $categories_per_row) { ?>
		<div class="clear"></div>
		</div>
			<?php
			$iCol = 1;
		} else {
			$iCol ++;
		}
	}
	}
	// Do we need a final closing row tag?
	if ($iCol != 1) { ?>
		<div class="clear"></div>
		</div>
	<?php } ?>
</div>

<?php }
}
?>
<div class="browse-view">
    <?php
if (!empty($this->keyword)) {
	?>
	<h3><?php echo $this->keyword; ?></h3>
	<?php
} ?>
 		<?php if ($this->search !==null ) { ?>
		    <form action="<?php echo JRoute::_('index.php?option=com_virtuemart&view=category&limitstart=0&virtuemart_category_id='.$this->category->virtuemart_category_id ); ?>" method="get">

		    <!--BEGIN Search Box --><div class="virtuemart_search">
		    <?php echo $this->searchcustom ?>
		    <br />
		    <?php echo $this->searchcustomvalues ?>
		    <input name="keyword" class="inputbox" type="text" size="20" value="<?php echo $this->keyword ?>" />
		    <input type="submit" value="<?php echo JText::_('COM_VIRTUEMART_SEARCH') ?>" class="button" onclick="this.form.keyword.focus();"/>
		    </div>
				    <input type="hidden" name="search" value="true" />
				    <input type="hidden" name="view" value="category" />

		    </form>
		<!-- End Search Box -->
		<?php } ?>

<?php // Show child categories
if (!empty($this->products)) {
?>
			<div class="orderby-displaynumber">
				<div class="width70 floatleft">
					<?php echo $this->orderByList['orderby']; ?>
					<?php echo $this->orderByList['manufacturer']; ?>
				</div>
				<div class="width30 floatright display-number"><?php echo $this->vmPagination->getResultsCounter();?><br/><?php echo $this->vmPagination->getLimitBox(); ?></div>
				<?php if($this->vmPagination->getPagesCounter()) { ?>
				<div id="bottom-pagination">
					<p class="pagescounter"><span><?php echo $this->vmPagination->getPagesCounter(); ?></span></p>
					<p class="pageslinks"><?php echo $this->vmPagination->getPagesLinks(); ?></p>
				</div>
				<?php } ?>
			<div class="clear"></div>
			</div> <!-- end of orderby-displaynumber -->

<?php
// Category and Columns Counter
$iBrowseCol = 1;
$iBrowseProduct = 1;

// Calculating Products Per Row
$BrowseProducts_per_row = $this->perRow;
$Browsecellwidth = ' width'.floor ( 100 / $BrowseProducts_per_row );

// Separator
$verticalseparator = " vertical-separator";

// Count products
$BrowseTotalProducts = 0;
foreach ( $this->products as $product ) {
   $BrowseTotalProducts ++;
}

// Start the Output
foreach ( $this->products as $product ) {

	// this is an indicator wether a row needs to be opened or not
	if ($iBrowseCol == 1) { ?>
	<div class="row row_pnum<?php echo $BrowseProducts_per_row ?>">
	<?php }

	// Show the vertical seperator
	if ($iBrowseProduct == $BrowseProducts_per_row or $iBrowseProduct % $BrowseProducts_per_row == 0) {
		$show_vertical_separator = ' ';
	} else {
		$show_vertical_separator = $verticalseparator;
	}

		// Show Products ?>
		<div class="product floatleft<?php echo $Browsecellwidth . $show_vertical_separator ?>">
			<div class="spacer">
				<div class="center">
						<div class="proimg-wrap">
							<?php /** @todo make image popup */
								echo $product->images[0]->displayMediaThumb('class="browseProductImage" border="0" title="'.$product->product_name.'" ',true,'class="modal"');
							?>
						</div>

						<!-- The "Average Customer Rating" Part -->
						<?php if ($this->showRating) { ?>
						<span class="contentpagetitle"><?php echo JText::_('COM_VIRTUEMART_CUSTOMER_RATING') ?>:</span>
						<br />
						<?php } ?>

						<?php
						if (!VmConfig::get('use_as_catalog') and !(VmConfig::get('stockhandle','none')=='none') && (VmConfig::get ( 'display_stock', 1 )) ){?>
						<div class="paddingtop8">
							<span class="vmicon vm2-<?php echo $product->stock->stock_level ?>" title="<?php echo $product->stock->stock_tip ?>"></span>
							<span class="stock-level"><?php echo JText::_('COM_VIRTUEMART_STOCK_LEVEL_DISPLAY_TITLE_TIP') ?></span>
						</div>
						<?php }?>
				</div>

				<div class="pro-item-info">

					<h2 class="pro-item-name"><?php echo JHTML::link($product->link, $product->product_name); ?></h2>
						
					<?php // Product Short Description
					if(!empty($product->product_s_desc)) { ?>
					<div class="product-s-desc"><?php echo shopFunctionsF::limitStringByWord($product->product_s_desc, 50, '...') ?></div>
					<?php } ?>
					
					<div class="pro-detail-wrap">
						<div class="product-price">
						<?php echo $this->currency->createPriceDiv('salesPrice','',$product->prices); ?>
						</div>
					
						<div class="addtocart-area">
							<form method="post" class="product" action="index.php">
			                    <?php
			                    // Product custom_fields
			                    if (!empty($product->customfieldsCart)) {  ?>
			                        <div class="product-fields">
			                        <?php foreach ($product->customfieldsCart as $field) { ?>
			
			                            <div style="display:inline-block;" class="product-field product-field-type-<?php echo $field->field_type ?>">
			                            <span class="product-fields-title" ><b><?php echo $field->custom_title ?></b></span>
			                            <?php echo JHTML::tooltip($field->custom_tip, $field->custom_title, 'tooltip.png'); ?>
			                            <span class="product-field-display"><?php echo $field->display ?></span>
			                            <span class="product-field-desc"><?php echo $field->custom_field_desc ?></span>
			                            </div>
			
			                        <?php } ?>
			                        </div>
			                    <?php } ?>
					
			                    <div class="addtocart-bar">
									<?php
			                        // Add the button
									$button_lbl = JText::_('COM_VIRTUEMART_CART_ADD_TO');
									$button_cls = ''; //$button_cls = 'addtocart_button';
									// Display the add to cart button
									$stockhandle = VmConfig::get('stockhandle','none');
									if(($stockhandle=='disableit' or $stockhandle=='disableadd') and ($product->product_in_stock - $product->product_ordered)<1){
										$button_lbl = JText::_('COM_VIRTUEMART_CART_NOTIFY');
										$button_cls = 'notify-button';
										$button_name = 'notifycustomer';
									}
									?>
									<?php // Display the add to cart button ?>
									<span class="addtocart-button">
										<input type="submit" name="addtocart"  class="addtocart-button" value="<?php echo $button_lbl ?>" title="<?php echo $button_lbl ?>" />
									</span>
			                        <div class="clear"></div>
			                    </div>
					
								<input type="hidden" value="1" name="quantity[]" class="quantity-input js-recalculate">
			                    <input type="hidden" class="pname" value="<?php echo $product->product_name ?>"/>
			                    <input type="hidden" name="option" value="com_virtuemart" />
			                    <input type="hidden" name="view" value="cart" />
			                    <noscript><input type="hidden" name="task" value="add" /></noscript>
			                    <input type="hidden" name="virtuemart_product_id[]" value="<?php echo $product->virtuemart_product_id ?>" />
			                    <input type="hidden" name="virtuemart_category_id[]" value="<?php echo $product->virtuemart_category_id ?>" />
			                </form>
							<div class="clear"></div>
			            </div>
					
						<?php // Product Details Button
						echo '<div class="pro-detail">'.JHTML::link($product->link, JText::_('COM_VIRTUEMART_PRODUCT_DETAILS'), array('title' => $product->product_name)).'</div>';
						?>
					</div>

				</div>
			<div class="clear"></div>
			</div><!-- end of spacer -->
		</div> <!-- end of product -->
	<?php

   // Do we need to close the current row now?
   if ($iBrowseCol == $BrowseProducts_per_row || $iBrowseProduct == $BrowseTotalProducts) {?>
   <div class="clear"></div>
   </div> <!-- end of row -->
      <?php
      $iBrowseCol = 1;
   } else {
      $iBrowseCol ++;
   }

   $iBrowseProduct ++;
} // end of foreach ( $this->products as $product )
// Do we need a final closing row tag?
if ($iBrowseCol != 1) { ?>
	<div class="clear"></div>

<?php
}
?>
<!-- /div removed valerie -->
	<?php if($this->vmPagination->getPagesCounter()) { ?>
	<div id="bottom-pagination">
		<p class="pagescounter"><span><?php echo $this->vmPagination->getPagesCounter(); ?></span></p>
		<p class="pageslinks"><?php echo $this->vmPagination->getPagesLinks(); ?></p>
	</div>
	<?php } ?>
<!-- /div removed valerie -->
<?php } elseif ($this->search !==null ) echo JText::_('COM_VIRTUEMART_NO_RESULT').($this->keyword? ' : ('. $this->keyword. ')' : '')
?>
</div><!-- end browse-view -->